<template>
  <div class="time-control d-flex flex-grow-1 flex-row">
    <div class="btn-group">
      <icon-button icon="backward" @click="decrementStep"/>
      <icon-button v-bind:text="currentTime | unixToFormat('YYYY-MM-DD HH:mm')" @click="select('date-time-panel')"/>
      <icon-button icon="forward" @click="incrementStep"/>
    </div>
    <div class="time-slider d-flex flex-grow-1">
      <div class="w-100 px-4 py-2">
        <vue-slider
          ref="slider"
          tooltip="none"
          :adsorb="true"
          :data="generateSteps()"
          v-model="step"/>
      </div>
    </div>
  </div>
</template>

<script>
//import moment from 'moment'
import { getTimeSteps } from '@/core/datetime'
import VueSlider from 'vue-slider-component'
import { IconButton } from '@/core/components'
import MomentMixin from '@/core/mixins/moment'
import { SET_WORKSPACE_CURRENT_PANEL } from '@/workspace/store/mutations'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'

export default {
  name: 'timecontrol',

  mixins: [
    WorkspaceGetter,
    MomentMixin,
  ],
  
  computed: {
    currentPanel: {
      get() {
        return this.$store.getters.workspaceCurrentPanel(this.workspaceId)
      }
    },

    currentTime: {
      get() {
        //return this.$store.getters.workspaceCurrentTime(this.workspaceId)
        return this.workspaceComponent.time
      }
    },

    step: {
      get() {
        //return this.$store.getters.workspaceCurrentTime(this.workspaceId)
        return this.workspaceComponent.time
      },

      set(value) {
        /*this.$store.commit(SET_WORKSPACE_CURRENT_TIME, {
          workspaceId: this.workspaceId,
          currentTime: value
        })*/
        this.workspaceComponent.time = value
      },
    },
  },

  methods: {
    decrementStep() {
      this.$refs.slider.setIndex(this.$refs.slider.getIndex() - 1)
    },

    incrementStep() {
      this.$refs.slider.setIndex(this.$refs.slider.getIndex() + 1)
    },

    select(panelName) {
      if(this.currentPanel === panelName) {
        this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
          workspaceId: this.workspaceId,
          panel: null,
        })
      } else {
        this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
          workspaceId: this.workspaceId,
          panel: panelName,
        })
      }
    },

    generateSteps() {
      return getTimeSteps()
    },
  },

  components: {
    IconButton,
    VueSlider,
  },
}
</script>
